#!/usr/local/bin/wish

global ix jx nstop w iseed output_file 
set output_file  output_data 

wm title . "Ising Model Simulation"
wm iconname . "ising"
wm minsize . 0 0

frame .bar -relief flat
button .bar.dismiss -text Dismiss -command exit \
     -width 8 -relief raised -borderwidth 1
button .bar.rwalk -text Run -command "run_simulation" \
     -width 8 -relief raised -borderwidth 1
frame .plot -relief flat
button .plot.plot1 -text Plot_2D -command "plot_output" \
     -width 8 -relief raised -borderwidth 1
button .plot.plot2 -text Moment -command "plot_moment" \
     -width 8 -relief raised -borderwidth 1

frame .ix  -relief groove -borderwidth 2
label .ix.1 -text ix: -width 8 -anchor w
entry .ix.e -width 20 -relief sunken -textvariable ix
frame .jx -relief groove -borderwidth 2
label .jx.1 -text jx: -width 8 -anchor w
entry .jx.e -width 20 -relief sunken -textvariable jx
frame .nstop -relief groove -borderwidth 2
label .nstop.1 -text nstop: -width 8 -anchor w
entry .nstop.e -width 20 -relief sunken -textvariable nstop
frame .w -relief groove -borderwidth 2
label .w.1 -text w: -width 8 -anchor w
entry .w.e -width 20 -relief sunken -textvariable w
frame .iseed -relief groove -borderwidth 2
label .iseed.1 -text iseed: -width 8 -anchor w
entry .iseed.e -width 20 -relief sunken -textvariable iseed

pack .bar -side top -fill x -padx 2 -pady 2
pack .bar.dismiss .bar.rwalk -side left -anchor w
pack .plot -side top -fill x -padx 2 -pady 2
pack .plot.plot1 .plot.plot2 -side left -anchor w
pack .ix  -side top -fill x -padx 2 -pady 4
pack .ix.1 -side left -anchor w
pack .ix.e -side left -anchor w -expand 1 -fill x
pack .jx -side top -fill x -padx 2 -pady 4
pack .jx.1 -side left -anchor w
pack .jx.e -side left -anchor w -expand 1 -fill x 
pack .nstop -side top -fill x -padx 2 -pady 4
pack .nstop.1 -side left -anchor w
pack .nstop.e -side left -anchor w -expand 1 -fill x 
pack .w -side top -fill x -padx 2 -pady 4
pack .w.1 -side left -anchor w
pack .w.e -side left -anchor w -expand 1 -fill x 
pack .iseed -side top -fill x -padx 2 -pady 4
pack .iseed.1 -side left -anchor w
pack .iseed.e -side left -anchor w -expand 1 -fill x 

proc run_simulation { } {
   global ix jx nstop w iseed output_file 
   set line "$ix $jx $nstop $w $iseed\n"
   puts "simulation start"
   exec -keepnewline ising << $line > $output_file
   puts "simulation end"
}

proc plot_output { } {
   global ix jx nstop w iseed output_file
#   set gpl [open "|gnuplot" w+]
   set gpl [open plot.in w]
   puts $gpl "plot '$output_file' with points 3 9\npause -1" 
   close $gpl
   puts "now plotting ... please wait"
   exec gnuplot plot.in
#   flush $gpl
}


proc plot_moment { } {
   global ix jx nstop w iseed output_file 
#   set gpl [open "|gnuplot" w+]
   set gpl [open plot.in w]
   puts $gpl "plot \[:\]\[0:1\] 'moment.data' \npause -1" 
   close $gpl
   puts "now plotting ... please wait"
   exec gnuplot plot.in
#   flush $gpl
}

