#!/usr/local/bin/wish

global var_n var_iseed output_file 
set output_file  output_data 

wm title . "Random Walk Simulation"
wm iconname . "random walk"
wm minsize . 0 0

frame .bar -relief flat
button .bar.dismiss -text Dismiss -command exit \
     -width 8 -relief raised -borderwidth 1
button .bar.rwalk -text Run -command "run_simulation" \
     -width 8 -relief raised -borderwidth 1
button .bar.plot -text Plot -command "plot_output" \
     -width 8 -relief raised -borderwidth 1
frame .n  -relief groove -borderwidth 2
label .n.1 -text n: -width 8 -anchor w
entry .n.e -width 20 -relief sunken -textvariable var_n
frame .iseed -relief groove -borderwidth 2
label .iseed.1 -text iseed: -width 8 -anchor w
entry .iseed.e -width 20 -relief sunken -textvariable var_iseed

pack .bar -side top -fill x -padx 2 -pady 2
pack .bar.dismiss .bar.rwalk .bar.plot -side left -anchor w
pack .n -side top -fill x -padx 2 -pady 4
pack .n.1 -side left -anchor w
pack .n.e -side left -anchor w -expand 1 -fill x
pack .iseed -side top -fill x -padx 2 -pady 4
pack .iseed.1 -side left -anchor w
pack .iseed.e -side left -anchor w -expand 1 -fill x 

proc run_simulation { } {
   global var_n var_iseed output_file
   set line "$var_n $var_iseed\n"
   puts "simulation start"
   exec -keepnewline rwalk << $line > $output_file
   puts "simulation end"
}

proc plot_output { } {
   global var_n var_iseed output_file
#   set gpl [open "|gnuplot" w+]
   set gpl [open plot.in w]
   puts $gpl "plot '$output_file' using 1:2 with lines\npause -1"
   close $gpl
   puts "now plotting ... please wait"
#  puts $gpl "plot '$output_file' using 1:2 with lines\n" 
   exec gnuplot plot.in
#  flush $gpl
}

