#!/usr/local/bin/wish
global qav gm ix nstop

wm title . "One-dimensional Shock Tube Simulation"
wm iconname . "shocktube"
wm minsize . 0 0

frame .bar -relief flat
button .bar.dismiss -text Dismiss -command exit \
     -width 8 -relief raised -borderwidth 1
button .bar.rwalk -text Run -command "run_simulation" \
     -width 8 -relief raised -borderwidth 1
frame .plot -relief flat
button .plot.plot1 -text Plot_ro -command "plot_output {output.density}" \
     -width 8 -relief raised -borderwidth 1
button .plot.plot2 -text Plot_vx -command "plot_output {output.velocity}" \
     -width 8 -relief raised -borderwidth 1
button .plot.plot3 -text Plot_pr -command "plot_output {output.pressure}" \
     -width 8 -relief raised -borderwidth 1

frame .qav  -relief groove -borderwidth 2
label .qav.1 -text Qav: -width 8 -anchor w
entry .qav.e -width 20 -relief sunken -textvariable qav
frame .gm  -relief groove -borderwidth 2
label .gm.1 -text gamma: -width 8 -anchor w
entry .gm.e -width 20 -relief sunken -textvariable gm
frame .ix -relief groove -borderwidth 2
label .ix.1 -text grids: -width 8 -anchor w
entry .ix.e -width 20 -relief sunken -textvariable ix
frame .nstop -relief groove -borderwidth 2
label .nstop.1 -text steps: -width 8 -anchor w
entry .nstop.e -width 20 -relief sunken -textvariable nstop

pack .bar -side top -fill x -padx 2 -pady 2
pack .bar.dismiss .bar.rwalk -side left -anchor w
pack .plot -side top -fill x -padx 2 -pady 2
pack .plot.plot1 .plot.plot2 .plot.plot3 -side left -anchor w
pack .qav  -side top -fill x -padx 2 -pady 4
pack .qav.1 -side left -anchor w
pack .qav.e -side left -anchor w -expand 1 -fill x
pack .gm  -side top -fill x -padx 2 -pady 4
pack .gm.1 -side left -anchor w
pack .gm.e -side left -anchor w -expand 1 -fill x
pack .ix -side top -fill x -padx 2 -pady 4
pack .ix.1 -side left -anchor w
pack .ix.e -side left -anchor w -expand 1 -fill x 
pack .nstop -side top -fill x -padx 2 -pady 4
pack .nstop.1 -side left -anchor w
pack .nstop.e -side left -anchor w -expand 1 -fill x 

proc run_simulation { } {
   global qav gm ix nstop
   set line "$qav $gm $ix $nstop\n"
   puts "simulation start"
   exec -keepnewline lw1d << $line 
   puts "simulation end"
}

proc plot_output {output_file} {
   global qav gm ix nstop
#   set gpl [open "|gnuplot" w+]
   set gpl [open plot.in w]
   puts $gpl "plot '$output_file' with lines\npause -1" 
   close $gpl
   puts "now plotting ... please wait"
   exec gnuplot plot.in
#   flush $gpl
}
