/***********************************************/
/*   Restricted Three-Body Problem             */ 
/*           Simulation Program                */
/*                                             */
/*             1997.9.26   by Ryoji Matsumoto  */
/***********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(void)
{
	double x,y,vx,vy,t,dt,tmax,r,r3;
        double k0[4],k1[4],k2[4],k3[4];
        double x1,y1,vx1,vy1,x2,y2,vx2,vy2;
        double x3,y3,vx3,vy3,x4,y4,vx4,vy4;
        double xa,ya,xb,yb,ra,rb,ra3,rb3;

        xa=0.0;
        ya=0.0;
        xb=1.0;
        yb=0.0;
	scanf("%lf %lf %lf %lf %lf %lf",&x,&y,&vx,&vy,&dt,&tmax);
	for(t=0;t<tmax;t+=dt) {
   	        ra = sqrt((x-xa)*(x-xa)+(y-ya)*(y-ya));
                rb = sqrt((x-xb)*(x-xb)+(y-yb)*(y-yb));
                if ((ra < 0.01)||(rb < 0.01)) break;
                ra3= ra*ra*ra;
                rb3= rb*rb*rb;
                k0[0]=dt*vx;
                k0[1]=dt*vy;
                k0[2]=dt*(-(x-xa)/ra3-(x-xb)/rb3);
                k0[3]=dt*(-(y-ya)/ra3-(y-yb)/rb3);
                x1 = x+k0[0]/2.0;
                y1 = y+k0[1]/2.0;
                vx1= vx+k0[2]/2.0;
                vy1= vy+k0[3]/2.0;
                ra = sqrt((x1-xa)*(x1-xa)+(y1-ya)*(y1-ya));
                rb = sqrt((x1-xb)*(x1-xb)+(y1-yb)*(y1-yb));
                ra3= ra*ra*ra;
                rb3= rb*rb*rb;
		k1[0]=dt*vx1;
		k1[1]=dt*vy1;
		k1[2]=dt*(-(x1-xa)/ra3-(x1-xb)/rb3);
		k1[3]=dt*(-(y1-ya)/ra3-(y1-yb)/rb3);
		x2 = x+k1[0]/2.0;
		y2 = y+k1[1]/2.0;
		vx2= vx+k1[2]/2.0;
		vy2= vy+k1[3]/2.0;
		ra = sqrt((x2-xa)*(x2-xa)+(y2-ya)*(y2-ya));
                rb = sqrt((x2-xb)*(x2-xb)+(y2-yb)*(y2-yb));
                ra3= ra*ra*ra;
                rb3= rb*rb*rb;
		k2[0]=dt*vx2;
		k2[1]=dt*vy2;
		k2[2]=dt*(-(x2-xa)/ra3-(x2-xb)/rb3);
		k2[3]=dt*(-(y2-ya)/ra3-(y2-yb)/rb3);
		x3 =x+k2[0];
		y3 =y+k2[1];
		vx3=vx+k2[2];
		vy3=vy+k2[3];
		ra = sqrt((x3-xa)*(x3-xa)+(y3-ya)*(y3-ya));
                rb = sqrt((x3-xb)*(x3-xb)+(y3-yb)*(y3-yb));
                ra3= ra*ra*ra;
                rb3= rb*rb*rb;
		k3[0]=dt*vx3;
		k3[1]=dt*vy3;
		k3[2]=dt*(-(x3-xa)/ra3-(x3-xb)/rb3);
		k3[3]=dt*(-(y3-ya)/ra3-(y3-yb)/rb3);
		x =x +(k0[0]+2.0*k1[0]+2.0*k2[0]+k3[0])/6.0;
                y =y +(k0[1]+2.0*k1[1]+2.0*k2[1]+k3[1])/6.0;
		vx=vx+(k0[2]+2.0*k1[2]+2.0*k2[2]+k3[2])/6.0;
		vy=vy+(k0[3]+2.0*k1[3]+2.0*k2[3]+k3[3])/6.0;
                printf("%f %f %f %f\n",t+dt,x,y,vx,vy);
        }

        return(0);
}          
