#!/usr/local/bin/wish
global var_x var_y var_vx var_vy var_dt var_tmax output_file 
set output_file  output_data 

wm title . "Two-Body Problem Simulation"
wm iconname . "twobody"
wm minsize . 0 0

frame .bar -relief flat
button .bar.dismiss -text Dismiss -command exit \
     -width 8 -relief raised -borderwidth 1
button .bar.rwalk -text Run -command "run_simulation" \
     -width 8 -relief raised -borderwidth 1
button .bar.plot -text Plot -command "plot_output" \
     -width 8 -relief raised -borderwidth 1
frame .x  -relief groove -borderwidth 2
label .x.1 -text x: -width 8 -anchor w
entry .x.e -width 20 -relief sunken -textvariable var_x
frame .y -relief groove -borderwidth 2
label .y.1 -text y: -width 8 -anchor w
entry .y.e -width 20 -relief sunken -textvariable var_y
frame .vx -relief groove -borderwidth 2
label .vx.1 -text vx: -width 8 -anchor w
entry .vx.e -width 20 -relief sunken -textvariable var_vx
frame .vy -relief groove -borderwidth 2
label .vy.1 -text vy: -width 8 -anchor w
entry .vy.e -width 20 -relief sunken -textvariable var_vy
frame .dt -relief groove -borderwidth 2
label .dt.1 -text dt: -width 8 -anchor w
entry .dt.e -width 20 -relief sunken -textvariable var_dt
frame .tmax -relief groove -borderwidth 2
label .tmax.1 -text tmax: -width 8 -anchor w
entry .tmax.e -width 20 -relief sunken -textvariable var_tmax

pack .bar -side top -fill x -padx 2 -pady 2
pack .bar.dismiss .bar.rwalk .bar.plot -side left -anchor w
pack .x  -side top -fill x -padx 2 -pady 4
pack .x.1 -side left -anchor w
pack .x.e -side left -anchor w -expand 1 -fill x
pack .y -side top -fill x -padx 2 -pady 4
pack .y.1 -side left -anchor w
pack .y.e -side left -anchor w -expand 1 -fill x 
pack .vx -side top -fill x -padx 2 -pady 4
pack .vx.1 -side left -anchor w
pack .vx.e -side left -anchor w -expand 1 -fill x 
pack .vy -side top -fill x -padx 2 -pady 4
pack .vy.1 -side left -anchor w
pack .vy.e -side left -anchor w -expand 1 -fill x 
pack .dt -side top -fill x -padx 2 -pady 4
pack .dt.1 -side left -anchor w
pack .dt.e -side left -anchor w -expand 1 -fill x 
pack .tmax -side top -fill x -padx 2 -pady 4
pack .tmax.1 -side left -anchor w
pack .tmax.e -side left -anchor w -expand 1 -fill x 

proc run_simulation { } {
   global var_x var_y var_vx var_vy var_dt var_tmax output_file 
   set line "$var_x $var_y $var_vx $var_vy $var_dt $var_tmax\n"
   puts "simulation start"
   exec -keepnewline ./twobody << $line > $output_file
   puts "simulation end"
}

proc plot_output { } {
   global var_x var_y var_vx var_vy var_dt var_tmax output_file 
#   set gpl [open "|gnuplot" w+]
   set gpl [open plot.in w]
   puts $gpl "plot '$output_file' using 2:3 with lines\npause -1" 
   close $gpl
   puts "now plotting ... please wait"
   exec gnuplot plot.in
#   flush $gpl
}
